{
  This file was automatically generated on 2024-02-27.

  Delphi/Lazarus Bindings Version 2.1.33

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletIndustrialDualACIn;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_DEVICE_IDENTIFIER = 2174;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_DEVICE_DISPLAY_NAME = 'Industrial Dual AC In Bricklet';

  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_VALUE_CALLBACK_CONFIGURATION = 2;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE_CALLBACK_CONFIGURATION = 3;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_ALL_VALUE_CALLBACK_CONFIGURATION = 4;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_ALL_VALUE_CALLBACK_CONFIGURATION = 5;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_CHANNEL_LED_CONFIG = 6;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHANNEL_LED_CONFIG = 7;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_RESET = 243;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_UID = 248;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_READ_UID = 249;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CALLBACK_VALUE = 8;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CALLBACK_ALL_VALUE = 9;

  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_0 = 0;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_1 = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_LED_CONFIG_OFF = 0;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_LED_CONFIG_ON = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_INDUSTRIAL_DUAL_AC_IN_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To1OfBoolean = array [0..1] of boolean;
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletIndustrialDualACIn = class;
  TBrickletIndustrialDualACInNotifyValue = procedure(sender: TBrickletIndustrialDualACIn; const channel: byte; const changed: boolean; const value: boolean) of object;
  TBrickletIndustrialDualACInNotifyAllValue = procedure(sender: TBrickletIndustrialDualACIn; const changed: TArray0To1OfBoolean; const value: TArray0To1OfBoolean) of object;

  /// <summary>
  ///  2 inputs that can detect AC voltages of up to 230V
  /// </summary>
  TBrickletIndustrialDualACIn = class(TDevice)
  private
    valueCallback: TBrickletIndustrialDualACInNotifyValue;
    allValueCallback: TBrickletIndustrialDualACInNotifyAllValue;
  protected
    procedure CallbackWrapperValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperAllValue(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the input values as bools, *true* refers to "AC voltage detected" and *false* refers to no AC "voltage detected".
    /// </summary>
    function GetValue: TArray0To1OfBoolean; virtual;

    /// <summary>
    ///  This callback can be configured per channel.
    ///  
    ///  The period is the period with which the <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.OnValue"/>
    ///  callback is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change within the
    ///  period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetValueCallbackConfiguration(const channel: byte; const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration for the given channel as set by
    ///  <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetValueCallbackConfiguration"/>.
    /// </summary>
    procedure GetValueCallbackConfiguration(const channel: byte; out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.OnAllValue"/>
    ///  callback is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change within the
    ///  period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetAllValueCallbackConfiguration(const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetAllValueCallbackConfiguration"/>.
    /// </summary>
    procedure GetAllValueCallbackConfiguration(out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Each channel has a corresponding LED. You can turn the LED off, on or show a
    ///  heartbeat. You can also set the LED to "Channel Status". In this mode the
    ///  LED is on if the channel is high and off otherwise.
    ///  
    ///  By default all channel LEDs are configured as "Channel Status".
    /// </summary>
    procedure SetChannelLEDConfig(const channel: byte; const config: byte); virtual;

    /// <summary>
    ///  Returns the channel LED configuration as set by <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetChannelLEDConfig"/>
    /// </summary>
    function GetChannelLEDConfig(const channel: byte): byte; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetValueCallbackConfiguration"/>.
    ///  
    ///  The parameters are the channel, a value-changed indicator and the actual
    ///  value for the channel. The `changed` parameter is true if the value has changed
    ///  since the last callback.
    /// </summary>
    property OnValue: TBrickletIndustrialDualACInNotifyValue read valueCallback write valueCallback;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.SetAllValueCallbackConfiguration"/>.
    ///  
    ///  The parameters are the same as <see cref="BrickletIndustrialDualACIn.TBrickletIndustrialDualACIn.GetValue"/>. Additional the
    ///  `changed` parameter is true if the value has changed since
    ///  the last callback.
    /// </summary>
    property OnAllValue: TBrickletIndustrialDualACInNotifyAllValue read allValueCallback write allValueCallback;
  end;

implementation

constructor TBrickletIndustrialDualACIn.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_INDUSTRIAL_DUAL_AC_IN_DEVICE_IDENTIFIER, BRICKLET_INDUSTRIAL_DUAL_AC_IN_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_ALL_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_ALL_VALUE_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_CHANNEL_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHANNEL_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_INDUSTRIAL_DUAL_AC_IN_CALLBACK_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperValue;
  callbackWrappers[BRICKLET_INDUSTRIAL_DUAL_AC_IN_CALLBACK_ALL_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAllValue;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletIndustrialDualACIn.GetValue: TArray0To1OfBoolean;
var request, response: TByteArray; i: longint; valueBits: array [0..0] of byte;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE, 8);
  response := SendRequest(request, 9);
  FillChar(valueBits[0], Length(valueBits) * SizeOf(valueBits[0]), 0);
  for i := 0 to 0 do valueBits[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 1 do result[i] := ((valueBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
end;

procedure TBrickletIndustrialDualACIn.SetValueCallbackConfiguration(const channel: byte; const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_VALUE_CALLBACK_CONFIGURATION, 14);
  LEConvertUInt8To(channel, 8, request);
  LEConvertUInt32To(period, 9, request);
  LEConvertBooleanTo(valueHasToChange, 13, request);
  SendRequest(request, 0);
end;

procedure TBrickletIndustrialDualACIn.GetValueCallbackConfiguration(const channel: byte; out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_VALUE_CALLBACK_CONFIGURATION, 9);
  LEConvertUInt8To(channel, 8, request);
  response := SendRequest(request, 13);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

procedure TBrickletIndustrialDualACIn.SetAllValueCallbackConfiguration(const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_ALL_VALUE_CALLBACK_CONFIGURATION, 13);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletIndustrialDualACIn.GetAllValueCallbackConfiguration(out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_ALL_VALUE_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 13);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

procedure TBrickletIndustrialDualACIn.SetChannelLEDConfig(const channel: byte; const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_CHANNEL_LED_CONFIG, 10);
  LEConvertUInt8To(channel, 8, request);
  LEConvertUInt8To(config, 9, request);
  SendRequest(request, 0);
end;

function TBrickletIndustrialDualACIn.GetChannelLEDConfig(const channel: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHANNEL_LED_CONFIG, 9);
  LEConvertUInt8To(channel, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletIndustrialDualACIn.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletIndustrialDualACIn.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletIndustrialDualACIn.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletIndustrialDualACIn.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletIndustrialDualACIn.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletIndustrialDualACIn.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletIndustrialDualACIn.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletIndustrialDualACIn.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletIndustrialDualACIn.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletIndustrialDualACIn.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletIndustrialDualACIn.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletIndustrialDualACIn.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_INDUSTRIAL_DUAL_AC_IN_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletIndustrialDualACIn.CallbackWrapperValue(const packet: TByteArray);
var channel: byte; changed: boolean; value: boolean;
begin
  if (Length(packet) <> 11) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  channel := LEConvertUInt8From(8, packet);
  changed := LEConvertBooleanFrom(9, packet);
  value := LEConvertBooleanFrom(10, packet);
  if (Assigned(valueCallback)) then begin
    valueCallback(self, channel, changed, value);
  end;
end;

procedure TBrickletIndustrialDualACIn.CallbackWrapperAllValue(const packet: TByteArray);
var changed: TArray0To1OfBoolean; value: TArray0To1OfBoolean; i: longint; changedBits: array [0..0] of byte; valueBits: array [0..0] of byte;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  FillChar(changedBits[0], Length(changedBits) * SizeOf(changedBits[0]), 0);
  for i := 0 to 0 do changedBits[i] := LEConvertUInt8From(8 + (i * 1), packet);
  for i := 0 to 1 do changed[i] := ((changedBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  FillChar(valueBits[0], Length(valueBits) * SizeOf(valueBits[0]), 0);
  for i := 0 to 0 do valueBits[i] := LEConvertUInt8From(9 + (i * 1), packet);
  for i := 0 to 1 do value[i] := ((valueBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  if (Assigned(allValueCallback)) then begin
    allValueCallback(self, changed, value);
  end;
end;

end.
