{
  This file was automatically generated on 2024-02-27.

  Delphi/Lazarus Bindings Version 2.1.33

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletLaserRangeFinder;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_LASER_RANGE_FINDER_DEVICE_IDENTIFIER = 255;
  BRICKLET_LASER_RANGE_FINDER_DEVICE_DISPLAY_NAME = 'Laser Range Finder Bricklet';

  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE = 1;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY = 2;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 3;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 4;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_PERIOD = 5;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_PERIOD = 6;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 7;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 8;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD = 9;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD = 10;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MOVING_AVERAGE = 13;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MOVING_AVERAGE = 14;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MODE = 15;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MODE = 16;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_ENABLE_LASER = 17;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_DISABLE_LASER = 18;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_IS_LASER_ENABLED = 19;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_SENSOR_HARDWARE_VERSION = 24;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_CONFIGURATION = 25;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_CONFIGURATION = 26;
  BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_LASER_RANGE_FINDER_CALLBACK_DISTANCE = 20;
  BRICKLET_LASER_RANGE_FINDER_CALLBACK_VELOCITY = 21;
  BRICKLET_LASER_RANGE_FINDER_CALLBACK_DISTANCE_REACHED = 22;
  BRICKLET_LASER_RANGE_FINDER_CALLBACK_VELOCITY_REACHED = 23;

  BRICKLET_LASER_RANGE_FINDER_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_LASER_RANGE_FINDER_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_LASER_RANGE_FINDER_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_LASER_RANGE_FINDER_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_LASER_RANGE_FINDER_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_LASER_RANGE_FINDER_MODE_DISTANCE = 0;
  BRICKLET_LASER_RANGE_FINDER_MODE_VELOCITY_MAX_13MS = 1;
  BRICKLET_LASER_RANGE_FINDER_MODE_VELOCITY_MAX_32MS = 2;
  BRICKLET_LASER_RANGE_FINDER_MODE_VELOCITY_MAX_64MS = 3;
  BRICKLET_LASER_RANGE_FINDER_MODE_VELOCITY_MAX_127MS = 4;
  BRICKLET_LASER_RANGE_FINDER_VERSION_1 = 1;
  BRICKLET_LASER_RANGE_FINDER_VERSION_3 = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;

  TBrickletLaserRangeFinder = class;
  TBrickletLaserRangeFinderNotifyDistance = procedure(sender: TBrickletLaserRangeFinder; const distance: word) of object;
  TBrickletLaserRangeFinderNotifyVelocity = procedure(sender: TBrickletLaserRangeFinder; const velocity: smallint) of object;
  TBrickletLaserRangeFinderNotifyDistanceReached = procedure(sender: TBrickletLaserRangeFinder; const distance: word) of object;
  TBrickletLaserRangeFinderNotifyVelocityReached = procedure(sender: TBrickletLaserRangeFinder; const velocity: smallint) of object;

  /// <summary>
  ///  Measures distance up to 40m with laser light
  /// </summary>
  TBrickletLaserRangeFinder = class(TDevice)
  private
    distanceCallback: TBrickletLaserRangeFinderNotifyDistance;
    velocityCallback: TBrickletLaserRangeFinderNotifyVelocity;
    distanceReachedCallback: TBrickletLaserRangeFinderNotifyDistanceReached;
    velocityReachedCallback: TBrickletLaserRangeFinderNotifyVelocityReached;
  protected
    procedure CallbackWrapperDistance(const packet: TByteArray); virtual;
    procedure CallbackWrapperVelocity(const packet: TByteArray); virtual;
    procedure CallbackWrapperDistanceReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperVelocityReached(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the measured distance.
    ///  
    ///  Sensor hardware version 1 (see <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.GetSensorHardwareVersion"/>) cannot
    ///  measure distance and velocity at the same time. Therefore, the distance mode
    ///  has to be enabled using <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetMode"/>.
    ///  Sensor hardware version 3 can measure distance and velocity at the same
    ///  time. Also the laser has to be enabled, see <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.EnableLaser"/>.
    ///  
    ///  If you want to get the distance periodically, it is recommended to
    ///  use the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistance"/> callback and set the period with
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackPeriod"/>.
    /// </summary>
    function GetDistance: word; virtual;

    /// <summary>
    ///  Returns the measured velocity.
    ///  
    ///  Sensor hardware version 1 (see <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.GetSensorHardwareVersion"/>) cannot
    ///  measure distance and velocity at the same time. Therefore, the velocity mode
    ///  has to be enabled using <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetMode"/>.
    ///  Sensor hardware version 3 can measure distance and velocity at the same
    ///  time, but the velocity measurement only produces stables results if a fixed
    ///  measurement rate (see <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetConfiguration"/>) is configured. Also the laser
    ///  has to be enabled, see <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.EnableLaser"/>.
    ///  
    ///  If you want to get the velocity periodically, it is recommended to
    ///  use the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocity"/> callback and set the period with
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackPeriod"/>.
    /// </summary>
    function GetVelocity: smallint; virtual;

    /// <summary>
    ///  Sets the period with which the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistance"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistance"/> callback is only triggered if the distance value has
    ///  changed since the last triggering.
    /// </summary>
    procedure SetDistanceCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackPeriod"/>.
    /// </summary>
    function GetDistanceCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period with which the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocity"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocity"/> callback is only triggered if the velocity value has
    ///  changed since the last triggering.
    /// </summary>
    procedure SetVelocityCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackPeriod"/>.
    /// </summary>
    function GetVelocityCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistanceReached"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the distance value is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the distance value is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the distance value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the distance value is greater than the min value (max is ignored)"
    ///  </code>
    /// </summary>
    procedure SetDistanceCallbackThreshold(const option: char; const min: word; const max: word); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackThreshold"/>.
    /// </summary>
    procedure GetDistanceCallbackThreshold(out option: char; out min: word; out max: word); virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocityReached"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the velocity is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the velocity is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the velocity is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the velocity is greater than the min value (max is ignored)"
    ///  </code>
    /// </summary>
    procedure SetVelocityCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackThreshold"/>.
    /// </summary>
    procedure GetVelocityCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;

    /// <summary>
    ///  Sets the period with which the threshold callbacks
    ///  
    ///  * <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistanceReached"/>,
    ///  * <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocityReached"/>,
    ///  
    ///  are triggered, if the thresholds
    ///  
    ///  * <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackThreshold"/>,
    ///  * <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackThreshold"/>,
    ///  
    ///  keep being reached.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
    ///  for the distance and velocity.
    ///  
    ///  Setting the length to 0 will turn the averaging completely off. With less
    ///  averaging, there is more noise on the data.
    /// </summary>
    procedure SetMovingAverage(const distanceAverageLength: byte; const velocityAverageLength: byte); virtual;

    /// <summary>
    ///  Returns the length moving average as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetMovingAverage"/>.
    /// </summary>
    procedure GetMovingAverage(out distanceAverageLength: byte; out velocityAverageLength: byte); virtual;

    /// <summary>
    ///  <note>
    ///   This function is only available if you have a LIDAR-Lite sensor with hardware
    ///   version 1. Use <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetConfiguration"/> for hardware version 3. You can check
    ///   the sensor hardware version using <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.GetSensorHardwareVersion"/>.
    ///  </note>
    ///  
    ///  The LIDAR-Lite sensor (hardware version 1) has five different modes. One mode is
    ///  for distance measurements and four modes are for velocity measurements with
    ///  different ranges.
    ///  
    ///  The following modes are available:
    ///  
    ///  * 0: Distance is measured with resolution 1.0 cm and range 0-4000 cm
    ///  * 1: Velocity is measured with resolution 0.1 m/s and range is 0-12.7 m/s
    ///  * 2: Velocity is measured with resolution 0.25 m/s and range is 0-31.75 m/s
    ///  * 3: Velocity is measured with resolution 0.5 m/s and range is 0-63.5 m/s
    ///  * 4: Velocity is measured with resolution 1.0 m/s and range is 0-127 m/s
    /// </summary>
    procedure SetMode(const mode: byte); virtual;

    /// <summary>
    ///  Returns the mode as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetMode"/>.
    /// </summary>
    function GetMode: byte; virtual;

    /// <summary>
    ///  Activates the laser of the LIDAR.
    ///  
    ///  We recommend that you wait 250ms after enabling the laser before
    ///  the first call of <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.GetDistance"/> to ensure stable measurements.
    /// </summary>
    procedure EnableLaser; virtual;

    /// <summary>
    ///  Deactivates the laser of the LIDAR.
    /// </summary>
    procedure DisableLaser; virtual;

    /// <summary>
    ///  Returns *true* if the laser is enabled, *false* otherwise.
    /// </summary>
    function IsLaserEnabled: boolean; virtual;

    /// <summary>
    ///  Returns the LIDAR-Lite hardware version.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    function GetSensorHardwareVersion: byte; virtual;

    /// <summary>
    ///  <note>
    ///   This function is only available if you have a LIDAR-Lite sensor with hardware
    ///   version 3. Use <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetMode"/> for hardware version 1. You can check
    ///   the sensor hardware version using <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.GetSensorHardwareVersion"/>.
    ///  </note>
    ///  
    ///  The **Acquisition Count** defines the number of times the Laser Range Finder Bricklet
    ///  will integrate acquisitions to find a correlation record peak. With a higher count,
    ///  the Bricklet can measure longer distances. With a lower count, the rate increases. The
    ///  allowed values are 1-255.
    ///  
    ///  If you set **Enable Quick Termination** to true, the distance measurement will be terminated
    ///  early if a high peak was already detected. This means that a higher measurement rate can be achieved
    ///  and long distances can be measured at the same time. However, the chance of false-positive
    ///  distance measurements increases.
    ///  
    ///  Normally the distance is calculated with a detection algorithm that uses peak value,
    ///  signal strength and noise. You can however also define a fixed **Threshold Value**.
    ///  Set this to a low value if you want to measure the distance to something that has
    ///  very little reflection (e.g. glass) and set it to a high value if you want to measure
    ///  the distance to something with a very high reflection (e.g. mirror). Set this to 0 to
    ///  use the default algorithm. The other allowed values are 1-255.
    ///  
    ///  Set the **Measurement Frequency** to force a fixed measurement rate. If set to 0,
    ///  the Laser Range Finder Bricklet will use the optimal frequency according to the other
    ///  configurations and the actual measured distance. Since the rate is not fixed in this case,
    ///  the velocity measurement is not stable. For a stable velocity measurement you should
    ///  set a fixed measurement frequency. The lower the frequency, the higher is the resolution
    ///  of the calculated velocity. The allowed values are 10Hz-500Hz (and 0 to turn the fixed
    ///  frequency off).
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    procedure SetConfiguration(const acquisitionCount: byte; const enableQuickTermination: boolean; const thresholdValue: byte; const measurementFrequency: word); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetConfiguration"/>.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    procedure GetConfiguration(out acquisitionCount: byte; out enableQuickTermination: boolean; out thresholdValue: byte; out measurementFrequency: word); virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackPeriod"/>. The parameter is the distance
    ///  value of the sensor.
    ///  
    ///  The <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnDistance"/> callback is only triggered if the distance value has changed
    ///  since the last triggering.
    /// </summary>
    property OnDistance: TBrickletLaserRangeFinderNotifyDistance read distanceCallback write distanceCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackPeriod"/>. The parameter is the velocity
    ///  value of the sensor.
    ///  
    ///  The <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.OnVelocity"/> callback is only triggered if the velocity has changed since
    ///  the last triggering.
    /// </summary>
    property OnVelocity: TBrickletLaserRangeFinderNotifyVelocity read velocityCallback write velocityCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDistanceCallbackThreshold"/> is reached.
    ///  The parameter is the distance value of the sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDebouncePeriod"/>.
    /// </summary>
    property OnDistanceReached: TBrickletLaserRangeFinderNotifyDistanceReached read distanceReachedCallback write distanceReachedCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetVelocityCallbackThreshold"/> is reached.
    ///  The parameter is the velocity value of the sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletLaserRangeFinder.TBrickletLaserRangeFinder.SetDebouncePeriod"/>.
    /// </summary>
    property OnVelocityReached: TBrickletLaserRangeFinderNotifyVelocityReached read velocityReachedCallback write velocityReachedCallback;
  end;

implementation

constructor TBrickletLaserRangeFinder.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_LASER_RANGE_FINDER_DEVICE_IDENTIFIER, BRICKLET_LASER_RANGE_FINDER_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 1;

  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MOVING_AVERAGE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MOVING_AVERAGE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MODE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_ENABLE_LASER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_DISABLE_LASER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_IS_LASER_ENABLED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_SENSOR_HARDWARE_VERSION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_LASER_RANGE_FINDER_CALLBACK_DISTANCE] := {$ifdef FPC}@{$endif}CallbackWrapperDistance;
  callbackWrappers[BRICKLET_LASER_RANGE_FINDER_CALLBACK_VELOCITY] := {$ifdef FPC}@{$endif}CallbackWrapperVelocity;
  callbackWrappers[BRICKLET_LASER_RANGE_FINDER_CALLBACK_DISTANCE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperDistanceReached;
  callbackWrappers[BRICKLET_LASER_RANGE_FINDER_CALLBACK_VELOCITY_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVelocityReached;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletLaserRangeFinder.GetDistance: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

function TBrickletLaserRangeFinder.GetVelocity: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletLaserRangeFinder.SetDistanceCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request, 0);
end;

function TBrickletLaserRangeFinder.GetDistanceCallbackPeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletLaserRangeFinder.SetVelocityCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request, 0);
end;

function TBrickletLaserRangeFinder.GetVelocityCallbackPeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletLaserRangeFinder.SetDistanceCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, 13);
  LEConvertCharTo(option, 8, request);
  LEConvertUInt16To(min, 9, request);
  LEConvertUInt16To(max, 11, request);
  SendRequest(request, 0);
end;

procedure TBrickletLaserRangeFinder.GetDistanceCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request, 13);
  option := LEConvertCharFrom(8, response);
  min := LEConvertUInt16From(9, response);
  max := LEConvertUInt16From(11, response);
end;

procedure TBrickletLaserRangeFinder.SetVelocityCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD, 13);
  LEConvertCharTo(option, 8, request);
  LEConvertInt16To(min, 9, request);
  LEConvertInt16To(max, 11, request);
  SendRequest(request, 0);
end;

procedure TBrickletLaserRangeFinder.GetVelocityCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request, 13);
  option := LEConvertCharFrom(8, response);
  min := LEConvertInt16From(9, response);
  max := LEConvertInt16From(11, response);
end;

procedure TBrickletLaserRangeFinder.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_DEBOUNCE_PERIOD, 12);
  LEConvertUInt32To(debounce, 8, request);
  SendRequest(request, 0);
end;

function TBrickletLaserRangeFinder.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_DEBOUNCE_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletLaserRangeFinder.SetMovingAverage(const distanceAverageLength: byte; const velocityAverageLength: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MOVING_AVERAGE, 10);
  LEConvertUInt8To(distanceAverageLength, 8, request);
  LEConvertUInt8To(velocityAverageLength, 9, request);
  SendRequest(request, 0);
end;

procedure TBrickletLaserRangeFinder.GetMovingAverage(out distanceAverageLength: byte; out velocityAverageLength: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MOVING_AVERAGE, 8);
  response := SendRequest(request, 10);
  distanceAverageLength := LEConvertUInt8From(8, response);
  velocityAverageLength := LEConvertUInt8From(9, response);
end;

procedure TBrickletLaserRangeFinder.SetMode(const mode: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  SendRequest(request, 0);
end;

function TBrickletLaserRangeFinder.GetMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletLaserRangeFinder.EnableLaser;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_ENABLE_LASER, 8);
  SendRequest(request, 0);
end;

procedure TBrickletLaserRangeFinder.DisableLaser;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_DISABLE_LASER, 8);
  SendRequest(request, 0);
end;

function TBrickletLaserRangeFinder.IsLaserEnabled: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_IS_LASER_ENABLED, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

function TBrickletLaserRangeFinder.GetSensorHardwareVersion: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_SENSOR_HARDWARE_VERSION, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletLaserRangeFinder.SetConfiguration(const acquisitionCount: byte; const enableQuickTermination: boolean; const thresholdValue: byte; const measurementFrequency: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_SET_CONFIGURATION, 13);
  LEConvertUInt8To(acquisitionCount, 8, request);
  LEConvertBooleanTo(enableQuickTermination, 9, request);
  LEConvertUInt8To(thresholdValue, 10, request);
  LEConvertUInt16To(measurementFrequency, 11, request);
  SendRequest(request, 0);
end;

procedure TBrickletLaserRangeFinder.GetConfiguration(out acquisitionCount: byte; out enableQuickTermination: boolean; out thresholdValue: byte; out measurementFrequency: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_CONFIGURATION, 8);
  response := SendRequest(request, 13);
  acquisitionCount := LEConvertUInt8From(8, response);
  enableQuickTermination := LEConvertBooleanFrom(9, response);
  thresholdValue := LEConvertUInt8From(10, response);
  measurementFrequency := LEConvertUInt16From(11, response);
end;

procedure TBrickletLaserRangeFinder.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_LASER_RANGE_FINDER_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletLaserRangeFinder.CallbackWrapperDistance(const packet: TByteArray);
var distance: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  distance := LEConvertUInt16From(8, packet);
  if (Assigned(distanceCallback)) then begin
    distanceCallback(self, distance);
  end;
end;

procedure TBrickletLaserRangeFinder.CallbackWrapperVelocity(const packet: TByteArray);
var velocity: smallint;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  velocity := LEConvertInt16From(8, packet);
  if (Assigned(velocityCallback)) then begin
    velocityCallback(self, velocity);
  end;
end;

procedure TBrickletLaserRangeFinder.CallbackWrapperDistanceReached(const packet: TByteArray);
var distance: word;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  distance := LEConvertUInt16From(8, packet);
  if (Assigned(distanceReachedCallback)) then begin
    distanceReachedCallback(self, distance);
  end;
end;

procedure TBrickletLaserRangeFinder.CallbackWrapperVelocityReached(const packet: TByteArray);
var velocity: smallint;
begin
  if (Length(packet) <> 10) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  velocity := LEConvertInt16From(8, packet);
  if (Assigned(velocityReachedCallback)) then begin
    velocityReachedCallback(self, velocity);
  end;
end;

end.
