{
  This file was automatically generated on 2024-02-27.

  Delphi/Lazarus Bindings Version 2.1.33

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletOutdoorWeather;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_OUTDOOR_WEATHER_DEVICE_IDENTIFIER = 288;
  BRICKLET_OUTDOOR_WEATHER_DEVICE_DISPLAY_NAME = 'Outdoor Weather Bricklet';

  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL = 1;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL = 2;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_DATA = 3;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_DATA = 4;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATION_CALLBACK_CONFIGURATION = 5;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_CALLBACK_CONFIGURATION = 6;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION = 7;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION = 8;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_RESET = 243;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_UID = 248;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_READ_UID = 249;
  BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_OUTDOOR_WEATHER_CALLBACK_STATION_DATA = 9;
  BRICKLET_OUTDOOR_WEATHER_CALLBACK_SENSOR_DATA = 10;

  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_N = 0;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_NNE = 1;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_NE = 2;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_ENE = 3;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_E = 4;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_ESE = 5;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_SE = 6;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_SSE = 7;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_S = 8;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_SSW = 9;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_SW = 10;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_WSW = 11;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_W = 12;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_WNW = 13;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_NW = 14;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_NNW = 15;
  BRICKLET_OUTDOOR_WEATHER_WIND_DIRECTION_ERROR = 255;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_OUTDOOR_WEATHER_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_OUTDOOR_WEATHER_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_OUTDOOR_WEATHER_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_OUTDOOR_WEATHER_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_OUTDOOR_WEATHER_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To59OfUInt8 = array [0..59] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArrayOfUInt8 = array of byte;

  TBrickletOutdoorWeather = class;
  TBrickletOutdoorWeatherNotifyStationData = procedure(sender: TBrickletOutdoorWeather; const identifier: byte; const temperature: smallint; const humidity: byte; const windSpeed: longword; const gustSpeed: longword; const rain: longword; const windDirection: byte; const batteryLow: boolean) of object;
  TBrickletOutdoorWeatherNotifySensorData = procedure(sender: TBrickletOutdoorWeather; const identifier: byte; const temperature: smallint; const humidity: byte) of object;

  /// <summary>
  ///  433MHz receiver for outdoor weather station
  /// </summary>
  TBrickletOutdoorWeather = class(TDevice)
  private
    streamMutex: TCriticalSection;
    stationDataCallback: TBrickletOutdoorWeatherNotifyStationData;
    sensorDataCallback: TBrickletOutdoorWeatherNotifySensorData;
  protected
    procedure CallbackWrapperStationData(const packet: TByteArray); virtual;
    procedure CallbackWrapperSensorData(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the identifiers (number between 0 and 255) of all `stations
    ///  &lt;https://www.tinkerforge.com/en/shop/accessories/sensors/outdoor-weather-station-ws-6147.html&gt;`__
    ///  that have been seen since the startup of the Bricklet.
    ///  
    ///  Each station gives itself a random identifier on first startup.
    ///  
    ///  Since firmware version 2.0.2 a station is removed from the list if no data was received for
    ///  12 hours.
    /// </summary>
    procedure GetStationIdentifiersLowLevel(out identifiersLength: word; out identifiersChunkOffset: word; out identifiersChunkData: TArray0To59OfUInt8); virtual;

    /// <summary>
    ///  Returns the identifiers (number between 0 and 255) of all `stations
    ///  &lt;https://www.tinkerforge.com/en/shop/accessories/sensors/outdoor-weather-station-ws-6147.html&gt;`__
    ///  that have been seen since the startup of the Bricklet.
    ///  
    ///  Each station gives itself a random identifier on first startup.
    ///  
    ///  Since firmware version 2.0.2 a station is removed from the list if no data was received for
    ///  12 hours.
    /// </summary>
    function GetStationIdentifiers: TArrayOfUInt8; virtual;

    /// <summary>
    ///  Returns the identifiers (number between 0 and 255) of all `sensors
    ///  &lt;https://www.tinkerforge.com/en/shop/accessories/sensors/temperature-humidity-sensor-th-6148.html&gt;`__
    ///  that have been seen since the startup of the Bricklet.
    ///  
    ///  Each sensor gives itself a random identifier on first startup.
    ///  
    ///  Since firmware version 2.0.2 a sensor is removed from the list if no data was received for
    ///  12 hours.
    /// </summary>
    procedure GetSensorIdentifiersLowLevel(out identifiersLength: word; out identifiersChunkOffset: word; out identifiersChunkData: TArray0To59OfUInt8); virtual;

    /// <summary>
    ///  Returns the identifiers (number between 0 and 255) of all `sensors
    ///  &lt;https://www.tinkerforge.com/en/shop/accessories/sensors/temperature-humidity-sensor-th-6148.html&gt;`__
    ///  that have been seen since the startup of the Bricklet.
    ///  
    ///  Each sensor gives itself a random identifier on first startup.
    ///  
    ///  Since firmware version 2.0.2 a sensor is removed from the list if no data was received for
    ///  12 hours.
    /// </summary>
    function GetSensorIdentifiers: TArrayOfUInt8; virtual;

    /// <summary>
    ///  Returns the last received data for a station with the given identifier.
    ///  Call <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.GetStationIdentifiers"/> for a list of all available identifiers.
    ///  
    ///  The return values are:
    ///  
    ///  * Temperature,
    ///  * Humidity,
    ///  * Wind Speed,
    ///  * Gust Speed,
    ///  * Rain Fall (accumulated since station power-up),
    ///  * Wind Direction,
    ///  * Battery Low (true if battery is low) and
    ///  * Last Change (seconds since the reception of this data).
    /// </summary>
    procedure GetStationData(const identifier: byte; out temperature: smallint; out humidity: byte; out windSpeed: longword; out gustSpeed: longword; out rain: longword; out windDirection: byte; out batteryLow: boolean; out lastChange: word); virtual;

    /// <summary>
    ///  Returns the last measured data for a sensor with the given identifier.
    ///  Call <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.GetSensorIdentifiers"/> for a list of all available identifiers.
    ///  
    ///  The return values are:
    ///  
    ///  * Temperature,
    ///  * Humidity and
    ///  * Last Change (seconds since the last reception of data).
    /// </summary>
    procedure GetSensorData(const identifier: byte; out temperature: smallint; out humidity: byte; out lastChange: word); virtual;

    /// <summary>
    ///  Turns callback for station data on or off.
    /// </summary>
    procedure SetStationCallbackConfiguration(const enableCallback: boolean); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetStationCallbackConfiguration"/>.
    /// </summary>
    function GetStationCallbackConfiguration: boolean; virtual;

    /// <summary>
    ///  Turns callback for sensor data on or off.
    /// </summary>
    procedure SetSensorCallbackConfiguration(const enableCallback: boolean); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetSensorCallbackConfiguration"/>.
    /// </summary>
    function GetSensorCallbackConfiguration: boolean; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  Reports the station data every time a new data packet is received.
    ///  See <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.GetStationData"/> for information about the data.
    ///  
    ///  For each station the callback will be triggered about every 45 seconds.
    ///  
    ///  Turn the callback on/off with <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetStationCallbackConfiguration"/>
    ///  (by default it is turned off).
    /// </summary>
    property OnStationData: TBrickletOutdoorWeatherNotifyStationData read stationDataCallback write stationDataCallback;

    /// <summary>
    ///  Reports the sensor data every time a new data packet is received.
    ///  See <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.GetSensorData"/> for information about the data.
    ///  
    ///  For each sensor the callback will be called about every 45 seconds.
    ///  
    ///  Turn the callback on/off with <see cref="BrickletOutdoorWeather.TBrickletOutdoorWeather.SetSensorCallbackConfiguration"/>
    ///  (by default it is turned off).
    /// </summary>
    property OnSensorData: TBrickletOutdoorWeatherNotifySensorData read sensorDataCallback write sensorDataCallback;
  end;

implementation

constructor TBrickletOutdoorWeather.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_OUTDOOR_WEATHER_DEVICE_IDENTIFIER, BRICKLET_OUTDOOR_WEATHER_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_DATA] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_DATA] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATION_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;

  callbackWrappers[BRICKLET_OUTDOOR_WEATHER_CALLBACK_STATION_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperStationData;
  callbackWrappers[BRICKLET_OUTDOOR_WEATHER_CALLBACK_SENSOR_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperSensorData;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletOutdoorWeather.GetStationIdentifiersLowLevel(out identifiersLength: word; out identifiersChunkOffset: word; out identifiersChunkData: TArray0To59OfUInt8);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_IDENTIFIERS_LOW_LEVEL, 8);
  response := SendRequest(request, 72);
  identifiersLength := LEConvertUInt16From(8, response);
  identifiersChunkOffset := LEConvertUInt16From(10, response);
  for i := 0 to 59 do identifiersChunkData[i] := LEConvertUInt8From(12 + (i * 1), response);
end;

function TBrickletOutdoorWeather.GetStationIdentifiers: TArrayOfUInt8;
var
  identifiers: TArrayOfUInt8;
  identifiersCurrentLength: word;
  identifiersLength: word;
  identifiersChunkOffset: word;
  identifiersChunkData: TArray0To59OfUInt8;
  identifiersOutOfSync: boolean;
  identifiersChunkLength: word;
begin
  result := []; { avoid compiler warning "function result variable of a managed type does not seem to be initialized" }
  SetLength(result, 0);
  SetLength(identifiers, 0);
  streamMutex.Acquire;
  try
    identifiersLength := 0;
    GetStationIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
    SetLength(identifiers, identifiersLength);
    identifiersOutOfSync := (identifiersChunkOffset <> 0);

    if ((not identifiersOutOfSync) and (identifiersLength > 0)) then begin
      identifiersChunkLength := identifiersLength - identifiersChunkOffset;
      if (identifiersChunkLength > 60) then identifiersChunkLength := 60;
      Move(identifiersChunkData, identifiers[0], SizeOf(byte) * identifiersChunkLength);
      identifiersCurrentLength := identifiersChunkLength;

      while ((not identifiersOutOfSync) and (identifiersCurrentLength < identifiersLength)) do begin
        GetStationIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
        identifiersOutOfSync := identifiersChunkOffset <> identifiersCurrentLength;
        identifiersChunkLength := identifiersLength - identifiersChunkOffset;
        if (identifiersChunkLength > 60) then identifiersChunkLength := 60;
        Move(identifiersChunkData, identifiers[identifiersCurrentLength], SizeOf(byte) * identifiersChunkLength);
        Inc(identifiersCurrentLength, identifiersChunkLength);
      end;
    end;

    if (identifiersOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (identifiersChunkOffset + 60 < identifiersLength) do begin
        GetStationIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
      end;

      raise EStreamOutOfSyncException.Create('Identifiers stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
  result := identifiers;
end;

procedure TBrickletOutdoorWeather.GetSensorIdentifiersLowLevel(out identifiersLength: word; out identifiersChunkOffset: word; out identifiersChunkData: TArray0To59OfUInt8);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_IDENTIFIERS_LOW_LEVEL, 8);
  response := SendRequest(request, 72);
  identifiersLength := LEConvertUInt16From(8, response);
  identifiersChunkOffset := LEConvertUInt16From(10, response);
  for i := 0 to 59 do identifiersChunkData[i] := LEConvertUInt8From(12 + (i * 1), response);
end;

function TBrickletOutdoorWeather.GetSensorIdentifiers: TArrayOfUInt8;
var
  identifiers: TArrayOfUInt8;
  identifiersCurrentLength: word;
  identifiersLength: word;
  identifiersChunkOffset: word;
  identifiersChunkData: TArray0To59OfUInt8;
  identifiersOutOfSync: boolean;
  identifiersChunkLength: word;
begin
  result := []; { avoid compiler warning "function result variable of a managed type does not seem to be initialized" }
  SetLength(result, 0);
  SetLength(identifiers, 0);
  streamMutex.Acquire;
  try
    identifiersLength := 0;
    GetSensorIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
    SetLength(identifiers, identifiersLength);
    identifiersOutOfSync := (identifiersChunkOffset <> 0);

    if ((not identifiersOutOfSync) and (identifiersLength > 0)) then begin
      identifiersChunkLength := identifiersLength - identifiersChunkOffset;
      if (identifiersChunkLength > 60) then identifiersChunkLength := 60;
      Move(identifiersChunkData, identifiers[0], SizeOf(byte) * identifiersChunkLength);
      identifiersCurrentLength := identifiersChunkLength;

      while ((not identifiersOutOfSync) and (identifiersCurrentLength < identifiersLength)) do begin
        GetSensorIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
        identifiersOutOfSync := identifiersChunkOffset <> identifiersCurrentLength;
        identifiersChunkLength := identifiersLength - identifiersChunkOffset;
        if (identifiersChunkLength > 60) then identifiersChunkLength := 60;
        Move(identifiersChunkData, identifiers[identifiersCurrentLength], SizeOf(byte) * identifiersChunkLength);
        Inc(identifiersCurrentLength, identifiersChunkLength);
      end;
    end;

    if (identifiersOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (identifiersChunkOffset + 60 < identifiersLength) do begin
        GetSensorIdentifiersLowLevel(identifiersLength, identifiersChunkOffset, identifiersChunkData);
      end;

      raise EStreamOutOfSyncException.Create('Identifiers stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
  result := identifiers;
end;

procedure TBrickletOutdoorWeather.GetStationData(const identifier: byte; out temperature: smallint; out humidity: byte; out windSpeed: longword; out gustSpeed: longword; out rain: longword; out windDirection: byte; out batteryLow: boolean; out lastChange: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_DATA, 9);
  LEConvertUInt8To(identifier, 8, request);
  response := SendRequest(request, 27);
  temperature := LEConvertInt16From(8, response);
  humidity := LEConvertUInt8From(10, response);
  windSpeed := LEConvertUInt32From(11, response);
  gustSpeed := LEConvertUInt32From(15, response);
  rain := LEConvertUInt32From(19, response);
  windDirection := LEConvertUInt8From(23, response);
  batteryLow := LEConvertBooleanFrom(24, response);
  lastChange := LEConvertUInt16From(25, response);
end;

procedure TBrickletOutdoorWeather.GetSensorData(const identifier: byte; out temperature: smallint; out humidity: byte; out lastChange: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_DATA, 9);
  LEConvertUInt8To(identifier, 8, request);
  response := SendRequest(request, 13);
  temperature := LEConvertInt16From(8, response);
  humidity := LEConvertUInt8From(10, response);
  lastChange := LEConvertUInt16From(11, response);
end;

procedure TBrickletOutdoorWeather.SetStationCallbackConfiguration(const enableCallback: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATION_CALLBACK_CONFIGURATION, 9);
  LEConvertBooleanTo(enableCallback, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOutdoorWeather.GetStationCallbackConfiguration: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATION_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletOutdoorWeather.SetSensorCallbackConfiguration(const enableCallback: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_SENSOR_CALLBACK_CONFIGURATION, 9);
  LEConvertBooleanTo(enableCallback, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOutdoorWeather.GetSensorCallbackConfiguration: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SENSOR_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletOutdoorWeather.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletOutdoorWeather.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOutdoorWeather.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOutdoorWeather.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOutdoorWeather.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOutdoorWeather.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOutdoorWeather.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOutdoorWeather.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletOutdoorWeather.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletOutdoorWeather.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletOutdoorWeather.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletOutdoorWeather.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OUTDOOR_WEATHER_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletOutdoorWeather.CallbackWrapperStationData(const packet: TByteArray);
var identifier: byte; temperature: smallint; humidity: byte; windSpeed: longword; gustSpeed: longword; rain: longword; windDirection: byte; batteryLow: boolean;
begin
  if (Length(packet) <> 26) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  identifier := LEConvertUInt8From(8, packet);
  temperature := LEConvertInt16From(9, packet);
  humidity := LEConvertUInt8From(11, packet);
  windSpeed := LEConvertUInt32From(12, packet);
  gustSpeed := LEConvertUInt32From(16, packet);
  rain := LEConvertUInt32From(20, packet);
  windDirection := LEConvertUInt8From(24, packet);
  batteryLow := LEConvertBooleanFrom(25, packet);
  if (Assigned(stationDataCallback)) then begin
    stationDataCallback(self, identifier, temperature, humidity, windSpeed, gustSpeed, rain, windDirection, batteryLow);
  end;
end;

procedure TBrickletOutdoorWeather.CallbackWrapperSensorData(const packet: TByteArray);
var identifier: byte; temperature: smallint; humidity: byte;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  identifier := LEConvertUInt8From(8, packet);
  temperature := LEConvertInt16From(9, packet);
  humidity := LEConvertUInt8From(11, packet);
  if (Assigned(sensorDataCallback)) then begin
    sensorDataCallback(self, identifier, temperature, humidity);
  end;
end;

end.
