{
  This file was automatically generated on 2024-02-27.

  Delphi/Lazarus Bindings Version 2.1.33

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletPiezoSpeakerV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_PIEZO_SPEAKER_V2_DEVICE_IDENTIFIER = 2145;
  BRICKLET_PIEZO_SPEAKER_V2_DEVICE_DISPLAY_NAME = 'Piezo Speaker Bricklet 2.0';

  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BEEP = 1;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BEEP = 2;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_ALARM = 3;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_ALARM = 4;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_VOLUME = 5;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_FREQUENCY = 6;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_RESET = 243;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_READ_UID = 249;
  BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_PIEZO_SPEAKER_V2_CALLBACK_BEEP_FINISHED = 7;
  BRICKLET_PIEZO_SPEAKER_V2_CALLBACK_ALARM_FINISHED = 8;

  BRICKLET_PIEZO_SPEAKER_V2_BEEP_DURATION_OFF = 0;
  BRICKLET_PIEZO_SPEAKER_V2_BEEP_DURATION_INFINITE = 4294967295;
  BRICKLET_PIEZO_SPEAKER_V2_ALARM_DURATION_OFF = 0;
  BRICKLET_PIEZO_SPEAKER_V2_ALARM_DURATION_INFINITE = 4294967295;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_PIEZO_SPEAKER_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_PIEZO_SPEAKER_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_PIEZO_SPEAKER_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_PIEZO_SPEAKER_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_PIEZO_SPEAKER_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletPiezoSpeakerV2 = class;
  TBrickletPiezoSpeakerV2NotifyBeepFinished = procedure(sender: TBrickletPiezoSpeakerV2) of object;
  TBrickletPiezoSpeakerV2NotifyAlarmFinished = procedure(sender: TBrickletPiezoSpeakerV2) of object;

  /// <summary>
  ///  Creates beep and alarm with configurable volume and frequency
  /// </summary>
  TBrickletPiezoSpeakerV2 = class(TDevice)
  private
    beepFinishedCallback: TBrickletPiezoSpeakerV2NotifyBeepFinished;
    alarmFinishedCallback: TBrickletPiezoSpeakerV2NotifyAlarmFinished;
  protected
    procedure CallbackWrapperBeepFinished(const packet: TByteArray); virtual;
    procedure CallbackWrapperAlarmFinished(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Beeps with the given frequency and volume for the duration.
    ///  
    ///  A duration of 0 stops the current beep if any is ongoing.
    ///  A duration of 4294967295 results in an infinite beep.
    /// </summary>
    procedure SetBeep(const frequency: word; const volume: byte; const duration: longword); virtual;

    /// <summary>
    ///  Returns the last beep settings as set by <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetBeep"/>. If a beep is currently
    ///  running it also returns the remaining duration of the beep.
    ///  
    ///  If the frequency or volume is updated during a beep (with <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.UpdateFrequency"/>
    ///  or <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.UpdateVolume"/>) this function returns the updated value.
    /// </summary>
    procedure GetBeep(out frequency: word; out volume: byte; out duration: longword; out durationRemaining: longword); virtual;

    /// <summary>
    ///  Creates an alarm (a tone that goes back and force between two specified frequencies).
    ///  
    ///  The following parameters can be set:
    ///  
    ///  * Start Frequency: Start frequency of the alarm.
    ///  * End Frequency: End frequency of the alarm.
    ///  * Step Size: Size of one step of the sweep between the start/end frequencies.
    ///  * Step Delay: Delay between two steps (duration of time that one tone is used in a sweep).
    ///  * Duration: Duration of the alarm.
    ///  
    ///  A duration of 0 stops the current alarm if any is ongoing.
    ///  A duration of 4294967295 results in an infinite alarm.
    ///  
    ///  Below you can find two sets of example settings that you can try out. You can use
    ///  these as a starting point to find an alarm signal that suits your application.
    ///  
    ///  Example 1: 10 seconds of loud annoying fast alarm
    ///  
    ///  * Start Frequency = 800
    ///  * End Frequency = 2000
    ///  * Step Size = 10
    ///  * Step Delay = 1
    ///  * Volume = 10
    ///  * Duration = 10000
    ///  
    ///  Example 2: 10 seconds of soft siren sound with slow build-up
    ///  
    ///  * Start Frequency = 250
    ///  * End Frequency = 750
    ///  * Step Size = 1
    ///  * Step Delay = 5
    ///  * Volume = 0
    ///  * Duration = 10000
    ///  
    ///  The following conditions must be met:
    ///  
    ///  * Start Frequency: has to be smaller than end frequency
    ///  * End Frequency: has to be bigger than start frequency
    ///  * Step Size: has to be small enough to fit into the frequency range
    ///  * Step Delay: has to be small enough to fit into the duration
    /// </summary>
    procedure SetAlarm(const startFrequency: word; const endFrequency: word; const stepSize: word; const stepDelay: word; const volume: byte; const duration: longword); virtual;

    /// <summary>
    ///  Returns the last alarm settings as set by <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetAlarm"/>. If an alarm is currently
    ///  running it also returns the remaining duration of the alarm as well as the
    ///  current frequency of the alarm.
    ///  
    ///  If the volume is updated during an alarm (with <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.UpdateVolume"/>)
    ///  this function returns the updated value.
    /// </summary>
    procedure GetAlarm(out startFrequency: word; out endFrequency: word; out stepSize: word; out stepDelay: word; out volume: byte; out duration: longword; out durationRemaining: longword; out currentFrequency: word); virtual;

    /// <summary>
    ///  Updates the volume of an ongoing beep or alarm.
    /// </summary>
    procedure UpdateVolume(const volume: byte); virtual;

    /// <summary>
    ///  Updates the frequency of an ongoing beep.
    /// </summary>
    procedure UpdateFrequency(const frequency: word); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered if a beep set by <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetBeep"/> is finished
    /// </summary>
    property OnBeepFinished: TBrickletPiezoSpeakerV2NotifyBeepFinished read beepFinishedCallback write beepFinishedCallback;

    /// <summary>
    ///  This callback is triggered if a alarm set by <see cref="BrickletPiezoSpeakerV2.TBrickletPiezoSpeakerV2.SetAlarm"/> is finished
    /// </summary>
    property OnAlarmFinished: TBrickletPiezoSpeakerV2NotifyAlarmFinished read alarmFinishedCallback write alarmFinishedCallback;
  end;

implementation

constructor TBrickletPiezoSpeakerV2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_PIEZO_SPEAKER_V2_DEVICE_IDENTIFIER, BRICKLET_PIEZO_SPEAKER_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BEEP] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BEEP] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_ALARM] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_ALARM] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_VOLUME] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_FREQUENCY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_PIEZO_SPEAKER_V2_CALLBACK_BEEP_FINISHED] := {$ifdef FPC}@{$endif}CallbackWrapperBeepFinished;
  callbackWrappers[BRICKLET_PIEZO_SPEAKER_V2_CALLBACK_ALARM_FINISHED] := {$ifdef FPC}@{$endif}CallbackWrapperAlarmFinished;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletPiezoSpeakerV2.SetBeep(const frequency: word; const volume: byte; const duration: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BEEP, 15);
  LEConvertUInt16To(frequency, 8, request);
  LEConvertUInt8To(volume, 10, request);
  LEConvertUInt32To(duration, 11, request);
  SendRequest(request, 0);
end;

procedure TBrickletPiezoSpeakerV2.GetBeep(out frequency: word; out volume: byte; out duration: longword; out durationRemaining: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BEEP, 8);
  response := SendRequest(request, 19);
  frequency := LEConvertUInt16From(8, response);
  volume := LEConvertUInt8From(10, response);
  duration := LEConvertUInt32From(11, response);
  durationRemaining := LEConvertUInt32From(15, response);
end;

procedure TBrickletPiezoSpeakerV2.SetAlarm(const startFrequency: word; const endFrequency: word; const stepSize: word; const stepDelay: word; const volume: byte; const duration: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_ALARM, 21);
  LEConvertUInt16To(startFrequency, 8, request);
  LEConvertUInt16To(endFrequency, 10, request);
  LEConvertUInt16To(stepSize, 12, request);
  LEConvertUInt16To(stepDelay, 14, request);
  LEConvertUInt8To(volume, 16, request);
  LEConvertUInt32To(duration, 17, request);
  SendRequest(request, 0);
end;

procedure TBrickletPiezoSpeakerV2.GetAlarm(out startFrequency: word; out endFrequency: word; out stepSize: word; out stepDelay: word; out volume: byte; out duration: longword; out durationRemaining: longword; out currentFrequency: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_ALARM, 8);
  response := SendRequest(request, 27);
  startFrequency := LEConvertUInt16From(8, response);
  endFrequency := LEConvertUInt16From(10, response);
  stepSize := LEConvertUInt16From(12, response);
  stepDelay := LEConvertUInt16From(14, response);
  volume := LEConvertUInt8From(16, response);
  duration := LEConvertUInt32From(17, response);
  durationRemaining := LEConvertUInt32From(21, response);
  currentFrequency := LEConvertUInt16From(25, response);
end;

procedure TBrickletPiezoSpeakerV2.UpdateVolume(const volume: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_VOLUME, 9);
  LEConvertUInt8To(volume, 8, request);
  SendRequest(request, 0);
end;

procedure TBrickletPiezoSpeakerV2.UpdateFrequency(const frequency: word);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_UPDATE_FREQUENCY, 10);
  LEConvertUInt16To(frequency, 8, request);
  SendRequest(request, 0);
end;

procedure TBrickletPiezoSpeakerV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletPiezoSpeakerV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletPiezoSpeakerV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletPiezoSpeakerV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletPiezoSpeakerV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletPiezoSpeakerV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletPiezoSpeakerV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletPiezoSpeakerV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletPiezoSpeakerV2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletPiezoSpeakerV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletPiezoSpeakerV2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletPiezoSpeakerV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_PIEZO_SPEAKER_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletPiezoSpeakerV2.CallbackWrapperBeepFinished(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(beepFinishedCallback)) then begin
    beepFinishedCallback(self);
  end;
end;

procedure TBrickletPiezoSpeakerV2.CallbackWrapperAlarmFinished(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(alarmFinishedCallback)) then begin
    alarmFinishedCallback(self);
  end;
end;

end.
