{
  This file was automatically generated on 2024-02-27.

  Delphi/Lazarus Bindings Version 2.1.33

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletServoV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_SERVO_V2_DEVICE_IDENTIFIER = 2157;
  BRICKLET_SERVO_V2_DEVICE_DISPLAY_NAME = 'Servo Bricklet 2.0';

  BRICKLET_SERVO_V2_FUNCTION_GET_STATUS = 1;
  BRICKLET_SERVO_V2_FUNCTION_SET_ENABLE = 2;
  BRICKLET_SERVO_V2_FUNCTION_GET_ENABLED = 3;
  BRICKLET_SERVO_V2_FUNCTION_SET_POSITION = 4;
  BRICKLET_SERVO_V2_FUNCTION_GET_POSITION = 5;
  BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_POSITION = 6;
  BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_VELOCITY = 7;
  BRICKLET_SERVO_V2_FUNCTION_SET_MOTION_CONFIGURATION = 8;
  BRICKLET_SERVO_V2_FUNCTION_GET_MOTION_CONFIGURATION = 9;
  BRICKLET_SERVO_V2_FUNCTION_SET_PULSE_WIDTH = 10;
  BRICKLET_SERVO_V2_FUNCTION_GET_PULSE_WIDTH = 11;
  BRICKLET_SERVO_V2_FUNCTION_SET_DEGREE = 12;
  BRICKLET_SERVO_V2_FUNCTION_GET_DEGREE = 13;
  BRICKLET_SERVO_V2_FUNCTION_SET_PERIOD = 14;
  BRICKLET_SERVO_V2_FUNCTION_GET_PERIOD = 15;
  BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT = 16;
  BRICKLET_SERVO_V2_FUNCTION_SET_SERVO_CURRENT_CONFIGURATION = 17;
  BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT_CONFIGURATION = 18;
  BRICKLET_SERVO_V2_FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION = 19;
  BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION = 20;
  BRICKLET_SERVO_V2_FUNCTION_GET_OVERALL_CURRENT = 21;
  BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE = 22;
  BRICKLET_SERVO_V2_FUNCTION_SET_CURRENT_CALIBRATION = 23;
  BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_CALIBRATION = 24;
  BRICKLET_SERVO_V2_FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION = 25;
  BRICKLET_SERVO_V2_FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION = 26;
  BRICKLET_SERVO_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_SERVO_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_SERVO_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_SERVO_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_SERVO_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_SERVO_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_SERVO_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_SERVO_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_SERVO_V2_FUNCTION_RESET = 243;
  BRICKLET_SERVO_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_SERVO_V2_FUNCTION_READ_UID = 249;
  BRICKLET_SERVO_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_SERVO_V2_CALLBACK_POSITION_REACHED = 27;

  BRICKLET_SERVO_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_SERVO_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_SERVO_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_SERVO_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_SERVO_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_SERVO_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_SERVO_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_SERVO_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_SERVO_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_SERVO_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArray0To9OfBoolean = array [0..9] of boolean;
  TArray0To9OfInt16 = array [0..9] of smallint;
  TArray0To9OfUInt16 = array [0..9] of word;

  TBrickletServoV2 = class;
  TBrickletServoV2NotifyPositionReached = procedure(sender: TBrickletServoV2; const servoChannel: word; const position: smallint) of object;

  /// <summary>
  ///  Drives up to 10 RC Servos
  /// </summary>
  TBrickletServoV2 = class(TDevice)
  private
    positionReachedCallback: TBrickletServoV2NotifyPositionReached;
  protected
    procedure CallbackWrapperPositionReached(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the status information of the Servo Bricklet 2.0.
    ///  
    ///  The status includes
    ///  
    ///  * for each channel if it is enabled or disabled,
    ///  * for each channel the current position,
    ///  * for each channel the current velocity,
    ///  * for each channel the current usage and
    ///  * the input voltage.
    ///  
    ///  Please note that the position and the velocity is a snapshot of the
    ///  current position and velocity of the servo in motion.
    /// </summary>
    procedure GetStatus(out enabled: TArray0To9OfBoolean; out currentPosition: TArray0To9OfInt16; out currentVelocity: TArray0To9OfInt16; out current: TArray0To9OfUInt16; out inputVoltage: word); virtual;

    /// <summary>
    ///  Enables a servo channel (0 to 9). If a servo is enabled, the configured position,
    ///  velocity, acceleration, etc. are applied immediately.
    /// </summary>
    procedure SetEnable(const servoChannel: word; const enable: boolean); virtual;

    /// <summary>
    ///  Returns *true* if the specified servo channel is enabled, *false* otherwise.
    /// </summary>
    function GetEnabled(const servoChannel: word): boolean; virtual;

    /// <summary>
    ///  Sets the position in °/100 for the specified servo channel.
    ///  
    ///  The default range of the position is -9000 to 9000, but it can be specified
    ///  according to your servo with <see cref="BrickletServoV2.TBrickletServoV2.SetDegree"/>.
    ///  
    ///  If you want to control a linear servo or RC brushless motor controller or
    ///  similar with the Servo Brick, you can also define lengths or speeds with
    ///  <see cref="BrickletServoV2.TBrickletServoV2.SetDegree"/>.
    /// </summary>
    procedure SetPosition(const servoChannel: word; const position: smallint); virtual;

    /// <summary>
    ///  Returns the position of the specified servo channel as set by <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/>.
    /// </summary>
    function GetPosition(const servoChannel: word): smallint; virtual;

    /// <summary>
    ///  Returns the *current* position of the specified servo channel. This may not be the
    ///  value of <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/> if the servo is currently approaching a
    ///  position goal.
    /// </summary>
    function GetCurrentPosition(const servoChannel: word): smallint; virtual;

    /// <summary>
    ///  Returns the *current* velocity of the specified servo channel. This may not be the
    ///  velocity specified by <see cref="BrickletServoV2.TBrickletServoV2.SetMotionConfiguration"/>. if the servo is
    ///  currently approaching a velocity goal.
    /// </summary>
    function GetCurrentVelocity(const servoChannel: word): word; virtual;

    /// <summary>
    ///  Sets the maximum velocity of the specified servo channel in °/100s as well as
    ///  the acceleration and deceleration in °/100s²
    ///  
    ///  With a velocity of 0 °/100s the position will be set immediately (no velocity).
    ///  
    ///  With an acc-/deceleration of 0 °/100s² the velocity will be set immediately
    ///  (no acc-/deceleration).
    /// </summary>
    procedure SetMotionConfiguration(const servoChannel: word; const velocity: longword; const acceleration: longword; const deceleration: longword); virtual;

    /// <summary>
    ///  Returns the motion configuration as set by <see cref="BrickletServoV2.TBrickletServoV2.SetMotionConfiguration"/>.
    /// </summary>
    procedure GetMotionConfiguration(const servoChannel: word; out velocity: longword; out acceleration: longword; out deceleration: longword); virtual;

    /// <summary>
    ///  Sets the minimum and maximum pulse width of the specified servo channel in µs.
    ///  
    ///  Usually, servos are controlled with a
    ///  `PWM &lt;https://en.wikipedia.org/wiki/Pulse-width_modulation&gt;`__, whereby the
    ///  length of the pulse controls the position of the servo. Every servo has
    ///  different minimum and maximum pulse widths, these can be specified with
    ///  this function.
    ///  
    ///  If you have a datasheet for your servo that specifies the minimum and
    ///  maximum pulse width, you should set the values accordingly. If your servo
    ///  comes without any datasheet you have to find the values via trial and error.
    ///  
    ///  Both values have a range from 1 to 65535 (unsigned 16-bit integer). The
    ///  minimum must be smaller than the maximum.
    ///  
    ///  The default values are 1000µs (1ms) and 2000µs (2ms) for minimum and
    ///  maximum pulse width.
    /// </summary>
    procedure SetPulseWidth(const servoChannel: word; const min: longword; const max: longword); virtual;

    /// <summary>
    ///  Returns the minimum and maximum pulse width for the specified servo channel as set by
    ///  <see cref="BrickletServoV2.TBrickletServoV2.SetPulseWidth"/>.
    /// </summary>
    procedure GetPulseWidth(const servoChannel: word; out min: longword; out max: longword); virtual;

    /// <summary>
    ///  Sets the minimum and maximum degree for the specified servo channel (by default
    ///  given as °/100).
    ///  
    ///  This only specifies the abstract values between which the minimum and maximum
    ///  pulse width is scaled. For example: If you specify a pulse width of 1000µs
    ///  to 2000µs and a degree range of -90° to 90°, a call of <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/>
    ///  with 0 will result in a pulse width of 1500µs
    ///  (-90° = 1000µs, 90° = 2000µs, etc.).
    ///  
    ///  Possible usage:
    ///  
    ///  * The datasheet of your servo specifies a range of 200° with the middle position
    ///    at 110°. In this case you can set the minimum to -9000 and the maximum to 11000.
    ///  * You measure a range of 220° on your servo and you don't have or need a middle
    ///    position. In this case you can set the minimum to 0 and the maximum to 22000.
    ///  * You have a linear servo with a drive length of 20cm, In this case you could
    ///    set the minimum to 0 and the maximum to 20000. Now you can set the Position
    ///    with <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/> with a resolution of cm/100. Also the velocity will
    ///    have a resolution of cm/100s and the acceleration will have a resolution of
    ///    cm/100s².
    ///  * You don't care about units and just want the highest possible resolution. In
    ///    this case you should set the minimum to -32767 and the maximum to 32767.
    ///  * You have a brushless motor with a maximum speed of 10000 rpm and want to
    ///    control it with a RC brushless motor controller. In this case you can set the
    ///    minimum to 0 and the maximum to 10000. <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/> now controls the rpm.
    ///  
    ///  Both values have a possible range from -32767 to 32767
    ///  (signed 16-bit integer). The minimum must be smaller than the maximum.
    ///  
    ///  The default values are -9000 and 9000 for the minimum and maximum degree.
    /// </summary>
    procedure SetDegree(const servoChannel: word; const min: smallint; const max: smallint); virtual;

    /// <summary>
    ///  Returns the minimum and maximum degree for the specified servo channel as set by
    ///  <see cref="BrickletServoV2.TBrickletServoV2.SetDegree"/>.
    /// </summary>
    procedure GetDegree(const servoChannel: word; out min: smallint; out max: smallint); virtual;

    /// <summary>
    ///  Sets the period of the specified servo channel in µs.
    ///  
    ///  Usually, servos are controlled with a
    ///  `PWM &lt;https://en.wikipedia.org/wiki/Pulse-width_modulation&gt;`__. Different
    ///  servos expect PWMs with different periods. Most servos run well with a
    ///  period of about 20ms.
    ///  
    ///  If your servo comes with a datasheet that specifies a period, you should
    ///  set it accordingly. If you don't have a datasheet and you have no idea
    ///  what the correct period is, the default value (19.5ms) will most likely
    ///  work fine.
    ///  
    ///  The minimum possible period is 1µs and the maximum is 1000000µs.
    ///  
    ///  The default value is 19.5ms (19500µs).
    /// </summary>
    procedure SetPeriod(const servoChannel: word; const period: longword); virtual;

    /// <summary>
    ///  Returns the period for the specified servo channel as set by <see cref="BrickletServoV2.TBrickletServoV2.SetPeriod"/>.
    /// </summary>
    function GetPeriod(const servoChannel: word): longword; virtual;

    /// <summary>
    ///  Returns the current consumption of the specified servo channel in mA.
    /// </summary>
    function GetServoCurrent(const servoChannel: word): word; virtual;

    /// <summary>
    ///  Sets the averaging duration of the current measurement for the specified servo channel in ms.
    /// </summary>
    procedure SetServoCurrentConfiguration(const servoChannel: word; const averagingDuration: byte); virtual;

    /// <summary>
    ///  Returns the servo current configuration for the specified servo channel as set
    ///  by <see cref="BrickletServoV2.TBrickletServoV2.SetServoCurrentConfiguration"/>.
    /// </summary>
    function GetServoCurrentConfiguration(const servoChannel: word): byte; virtual;

    /// <summary>
    ///  Sets the averaging duration of the input voltage measurement for the specified servo channel in ms.
    /// </summary>
    procedure SetInputVoltageConfiguration(const averagingDuration: byte); virtual;

    /// <summary>
    ///  Returns the input voltage configuration as set by <see cref="BrickletServoV2.TBrickletServoV2.SetInputVoltageConfiguration"/>.
    /// </summary>
    function GetInputVoltageConfiguration: byte; virtual;

    /// <summary>
    ///  Returns the current consumption of all servos together in mA.
    /// </summary>
    function GetOverallCurrent: word; virtual;

    /// <summary>
    ///  Returns the input voltage in mV. The input voltage is
    ///  given via the black power input connector on the Servo Brick.
    /// </summary>
    function GetInputVoltage: word; virtual;

    /// <summary>
    ///  Sets an offset value (in mA) for each channel.
    ///  
    ///  Note: On delivery the Servo Bricklet 2.0 is already calibrated.
    /// </summary>
    procedure SetCurrentCalibration(const offset: array of smallint); virtual;

    /// <summary>
    ///  Returns the current calibration as set by <see cref="BrickletServoV2.TBrickletServoV2.SetCurrentCalibration"/>.
    /// </summary>
    function GetCurrentCalibration: TArray0To9OfInt16; virtual;

    /// <summary>
    ///  Enable/Disable <see cref="BrickletServoV2.TBrickletServoV2.OnPositionReached"/> callback.
    /// </summary>
    procedure SetPositionReachedCallbackConfiguration(const servoChannel: word; const enabled: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletServoV2.TBrickletServoV2.SetPositionReachedCallbackConfiguration"/>.
    /// </summary>
    function GetPositionReachedCallbackConfiguration(const servoChannel: word): boolean; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletServoV2.TBrickletServoV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletServoV2.TBrickletServoV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletServoV2.TBrickletServoV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletServoV2.TBrickletServoV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered when a position set by <see cref="BrickletServoV2.TBrickletServoV2.SetPosition"/>
    ///  is reached. If the new position matches the current position then the
    ///  callback is not triggered, because the servo didn't move.
    ///  The parameters are the servo and the position that is reached.
    ///  
    ///  You can enable this callback with <see cref="BrickletServoV2.TBrickletServoV2.SetPositionReachedCallbackConfiguration"/>.
    ///  
    ///  <note>
    ///   Since we can't get any feedback from the servo, this only works if the
    ///   velocity (see <see cref="BrickletServoV2.TBrickletServoV2.SetMotionConfiguration"/>) is set smaller or equal to the
    ///   maximum velocity of the servo. Otherwise the servo will lag behind the
    ///   control value and the callback will be triggered too early.
    ///  </note>
    /// </summary>
    property OnPositionReached: TBrickletServoV2NotifyPositionReached read positionReachedCallback write positionReachedCallback;
  end;

implementation

constructor TBrickletServoV2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_SERVO_V2_DEVICE_IDENTIFIER, BRICKLET_SERVO_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_STATUS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_ENABLE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_ENABLED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_POSITION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_POSITION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_POSITION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_VELOCITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_MOTION_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_MOTION_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_PULSE_WIDTH] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_PULSE_WIDTH] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_DEGREE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_DEGREE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_PERIOD] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_SERVO_CURRENT_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_OVERALL_CURRENT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_CURRENT_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_SERVO_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_SERVO_V2_CALLBACK_POSITION_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperPositionReached;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletServoV2.GetStatus(out enabled: TArray0To9OfBoolean; out currentPosition: TArray0To9OfInt16; out currentVelocity: TArray0To9OfInt16; out current: TArray0To9OfUInt16; out inputVoltage: word);
var request, response: TByteArray; i: longint; enabledBits: array [0..1] of byte;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_STATUS, 8);
  response := SendRequest(request, 72);
  FillChar(enabledBits[0], Length(enabledBits) * SizeOf(enabledBits[0]), 0);
  for i := 0 to 1 do enabledBits[i] := LEConvertUInt8From(8 + (i * 1), response);
  for i := 0 to 9 do enabled[i] := ((enabledBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
  for i := 0 to 9 do currentPosition[i] := LEConvertInt16From(10 + (i * 2), response);
  for i := 0 to 9 do currentVelocity[i] := LEConvertInt16From(30 + (i * 2), response);
  for i := 0 to 9 do current[i] := LEConvertUInt16From(50 + (i * 2), response);
  inputVoltage := LEConvertUInt16From(70, response);
end;

procedure TBrickletServoV2.SetEnable(const servoChannel: word; const enable: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_ENABLE, 11);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertBooleanTo(enable, 10, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetEnabled(const servoChannel: word): boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_ENABLED, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletServoV2.SetPosition(const servoChannel: word; const position: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_POSITION, 12);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertInt16To(position, 10, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetPosition(const servoChannel: word): smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_POSITION, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

function TBrickletServoV2.GetCurrentPosition(const servoChannel: word): smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_POSITION, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

function TBrickletServoV2.GetCurrentVelocity(const servoChannel: word): word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_VELOCITY, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletServoV2.SetMotionConfiguration(const servoChannel: word; const velocity: longword; const acceleration: longword; const deceleration: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_MOTION_CONFIGURATION, 22);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertUInt32To(velocity, 10, request);
  LEConvertUInt32To(acceleration, 14, request);
  LEConvertUInt32To(deceleration, 18, request);
  SendRequest(request, 0);
end;

procedure TBrickletServoV2.GetMotionConfiguration(const servoChannel: word; out velocity: longword; out acceleration: longword; out deceleration: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_MOTION_CONFIGURATION, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 20);
  velocity := LEConvertUInt32From(8, response);
  acceleration := LEConvertUInt32From(12, response);
  deceleration := LEConvertUInt32From(16, response);
end;

procedure TBrickletServoV2.SetPulseWidth(const servoChannel: word; const min: longword; const max: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_PULSE_WIDTH, 18);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertUInt32To(min, 10, request);
  LEConvertUInt32To(max, 14, request);
  SendRequest(request, 0);
end;

procedure TBrickletServoV2.GetPulseWidth(const servoChannel: word; out min: longword; out max: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_PULSE_WIDTH, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 16);
  min := LEConvertUInt32From(8, response);
  max := LEConvertUInt32From(12, response);
end;

procedure TBrickletServoV2.SetDegree(const servoChannel: word; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_DEGREE, 14);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertInt16To(min, 10, request);
  LEConvertInt16To(max, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletServoV2.GetDegree(const servoChannel: word; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_DEGREE, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 12);
  min := LEConvertInt16From(8, response);
  max := LEConvertInt16From(10, response);
end;

procedure TBrickletServoV2.SetPeriod(const servoChannel: word; const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_PERIOD, 14);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertUInt32To(period, 10, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetPeriod(const servoChannel: word): longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_PERIOD, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

function TBrickletServoV2.GetServoCurrent(const servoChannel: word): word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletServoV2.SetServoCurrentConfiguration(const servoChannel: word; const averagingDuration: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_SERVO_CURRENT_CONFIGURATION, 11);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertUInt8To(averagingDuration, 10, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetServoCurrentConfiguration(const servoChannel: word): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_SERVO_CURRENT_CONFIGURATION, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletServoV2.SetInputVoltageConfiguration(const averagingDuration: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_INPUT_VOLTAGE_CONFIGURATION, 9);
  LEConvertUInt8To(averagingDuration, 8, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetInputVoltageConfiguration: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE_CONFIGURATION, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletServoV2.GetOverallCurrent: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_OVERALL_CURRENT, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

function TBrickletServoV2.GetInputVoltage: word;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_INPUT_VOLTAGE, 8);
  response := SendRequest(request, 10);
  result := LEConvertUInt16From(8, response);
end;

procedure TBrickletServoV2.SetCurrentCalibration(const offset: array of smallint);
var request: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_CURRENT_CALIBRATION, 28);
  if (Length(offset) <> 10) then raise EInvalidParameterException.Create('Offset has to be exactly 10 items long');
  for i := 0 to Length(offset) - 1 do LEConvertInt16To(offset[i], 8 + (i * 2), request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetCurrentCalibration: TArray0To9OfInt16;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_CURRENT_CALIBRATION, 8);
  response := SendRequest(request, 28);
  for i := 0 to 9 do result[i] := LEConvertInt16From(8 + (i * 2), response);
end;

procedure TBrickletServoV2.SetPositionReachedCallbackConfiguration(const servoChannel: word; const enabled: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_POSITION_REACHED_CALLBACK_CONFIGURATION, 11);
  LEConvertUInt16To(servoChannel, 8, request);
  LEConvertBooleanTo(enabled, 10, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetPositionReachedCallbackConfiguration(const servoChannel: word): boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_POSITION_REACHED_CALLBACK_CONFIGURATION, 10);
  LEConvertUInt16To(servoChannel, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletServoV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletServoV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletServoV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletServoV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletServoV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletServoV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletServoV2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletServoV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletServoV2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletServoV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_SERVO_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletServoV2.CallbackWrapperPositionReached(const packet: TByteArray);
var servoChannel: word; position: smallint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  servoChannel := LEConvertUInt16From(8, packet);
  position := LEConvertInt16From(10, packet);
  if (Assigned(positionReachedCallback)) then begin
    positionReachedCallback(self, servoChannel, position);
  end;
end;

end.
